// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	//load_preferences();
	
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
	save_preferences();

}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	save_preferences();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	load_preferences();
	if (updateInterval == null) {
		update_RSS_infomation();
	}	
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{	
	save_preferences();
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


//
//  original code follows...
//
//

// RSS feed part

var _httpReq = null;					// global constants.
var _rss_items;							// rss items to hold.
var _store_url;						// ITMS store URL.
var _current_track;					// current track shown on.
var _build_date = '';					// Time of ITMS RSS is bult.
var _current_genre = '';				//
var _current_store = '';				//
var _current_song_URL = '';			//
var _current_artist_URL = '';			//
var _current_album_URL = '';			//
var _elapsed_time = 0;				// for auto play.
var _current_rank,_current_song,_current_album,_current_artist,_current_album_source;

function RSS_URL(){

	var store_code = document.getElementById('store').value;
	var genre_code = document.getElementById('category').object.getValue();

	var url = 'http://ax.phobos.apple.com.edgesuite.net/WebObjects/MZStore.woa/wpa/MRSS/topsongs';

	if(genre_code!=0){
		url = url + '/sf=' + store_code + '/genre=' + genre_code + '/limit=100/rss.xml'; // 100 songs.
	}else{
	url = url + '/sf=' + store_code + '/limit=100/rss.xml'; // 100 songs.
	}
	
	return url;

}

function change_genre(){

	if (updateInterval != null){
		stop_auto_play();
	}
	
	
	update_RSS_infomation();
	
	//just to make sure.
	save_preferences();
}

function update_RSS_infomation(){
	
	fetch_from(RSS_URL());
	// fetch -> process -> parse -> items are obtained as global.
}

function fetch_from(uri_str){

	_httpReq = new XMLHttpRequest();					
	_httpReq.onreadystatechange = processReqChange;

	_httpReq.setRequestHeader("Cache-Control", "no-cache");
	_httpReq.overrideMimeType("text/xml");
	_httpReq.open('GET', uri_str);					// send it.
	_httpReq.send(null);
	
}

function processReqChange()								// called as a result of http call.
{	// this is called as request.
	

	if (_httpReq.readyState == 4){						// complete
	
		if (_httpReq.status == 200){						// success.

		  parse_result(_httpReq.responseText);
				  					
		  return(true);					
		  		
		} else {									

		  return(false);								// failed.
		}
	}

}


function parse_result(response_text){

	var build = RSS_parse_build_date(response_text);
	var genre = document.getElementById('category').object.getSelectedIndex();
	var store = document.getElementById('store').selectedIndex;
	
	if((build != _build_date) | (genre != _current_genre) | (store != _current_store)){
		_build_date = build;
		_current_genre = genre;
		_current_store = store;
		
		_rss_items = RSS_parse_items(response_text); // update items as global.
		_store_url = RSS_parse_store_URL(response_text);// update store_url as global.
		show_rss_track(0);
	}
}

//---------------------
//  RSS functions
//---------------------

function RSS_parse_store_URL(source){

	var str = source;
	var start_tag = str.indexOf('<link>');
	var end_tag = str.indexOf('</link>');
	str = str.substring(start_tag+6,end_tag);
	str = parse_escape_code(str);
	
	str = str.replace("http://","itms://");	// replace header.

	return str;
	
}

function RSS_parse_build_date(source){

	var str = source;
	var start_tag = str.indexOf('<lastBuildDate>');
	var end_tag = str.indexOf('</lastBuildDate>');
	str = str.substring(start_tag+15,end_tag);
	str = parse_escape_code(str);
	
	return str;
	
}


function RSS_parse_items(source){

	var items = new Array();
	var str = source;
	
	while(str.indexOf('<item>')>=0){
		var start_tag = str.indexOf('<item>');
		var end_tag = str.indexOf('</item>');
	
		if (start_tag >=0 && end_tag > start_tag) {
			atom = str.substring(start_tag,end_tag+7); // 7 = length of </items>
			items.push(atom);
			str = str.substring(end_tag+7+1,str.length);
		}
	}
		
	return items;
}


function RSS_retrieve_element(item,element_selector){

	switch (element_selector) {
		case 'itms:coverart':
			// itms:coverart, returns 100 * 100 image.
			var start = '<itms:coverArt height="100" width="100">';
			var end = '</itms:coverArt>';
			return string_between(item,start,end);
			break;
		
		default:
			//description,pubdate,itms:artist,category,itms:artistlink,itms:album
			//itms:albumlink,itms:albumprice,itms:song,itms:rank,itms:songlink
			//content:encoded,itms:rights,itms:releasedate,title,link
			var start = '<'+element_selector+'>';
			var end = '</'+element_selector+'>';
			var str = string_between(item,start,end);
			
			str = parse_escape_code(str);
			
			return str;
			break;
	}
}


function show_rss_track(track){

	var this_item = _rss_items[track];

	//update global constants.
	
	_current_track = track;
	_current_song_URL = RSS_retrieve_element(this_item,'itms:songLink');
	_current_artist_URL = RSS_retrieve_element(this_item,'itms:artistLink');
	_current_album_URL = RSS_retrieve_element(this_item,'itms:albumLink');
	
	//document.getElementById("rank").innerText = "No." + RSS_retrieve_element(this_item,'itms:rank');
	//document.getElementById("song").innerText = RSS_retrieve_element(this_item,'itms:song');
	//document.getElementById("album").innerText = RSS_retrieve_element(this_item,'itms:album');
	//document.getElementById("artist").innerText = RSS_retrieve_element(this_item,'itms:artist');
	//document.getElementById("album_image").src = RSS_retrieve_element(this_item,'itms:coverart');
	
	// a bit awkward...
	_current_rank = "No." + RSS_retrieve_element(this_item,'itms:rank');
	_current_song =  RSS_retrieve_element(this_item,'itms:song');
	_current_album = RSS_retrieve_element(this_item,'itms:album');
	_current_artist = RSS_retrieve_element(this_item,'itms:artist');
	_current_album_source = RSS_retrieve_element(this_item,'itms:coverart');

	start_opacity_effect_update_timer();
	
}

function show_next_rss_item(){

	if (_current_track <= _rss_items.length-1-1){
		_current_track = _current_track + 1;
		show_rss_track(_current_track);
		
		if(updateInterval != null){
			if(iTunes_is_playing()) {
				//say_song_information(_current_track);
				iTunes_next_track();
			}
		}
	}
}

function show_previous_rss_item(){

	if (_current_track >=1 ){
		_current_track = _current_track - 1;
		show_rss_track(_current_track);
		
		if(updateInterval != null){
			if(iTunes_is_playing()) {
				//say_song_information(_current_track);
				iTunes_previous_track();
			}
		}
	}
}


//
// auto play part follows.
//

var updateInterval = null;
//var current_track;

function start_auto_play(){

	_elapsed_time = 0;
	
	if(iTunes_is_running() == false){iTunes_activate();}
	
	iTunes_stop();
	
	iTunes_open(_store_url);
	delay(1);
	
	if(document.getElementById('hide_itunes').checked) {iTunes_hide()};

	//_current_track = 0; // just make sure.
	//show_rss_track(0);
	

	//say_category_information();
	//say_song_information(0);
	
	while(iTunes_is_playing() == false){
		delay(1);
		iTunes_move_playlist_position(_current_track);
		iTunes_play();
		_elapsed_time = _elapsed_time+1;
		
		if (_elapsed_time > 20) { return null;}

	}

	startUpdateTimer();

}

function stop_auto_play(){

	stopUpdateTimer();

	if(iTunes_is_running()){
		if(iTunes_is_playing()){
			iTunes_stop();
		};
	};
}

function startUpdateTimer()
{
    if (!updateInterval){
        updateInterval = setInterval(update_status, 1000);
	}
}

//
// Function: stopDisplayUpdateTimer()
// Remove the interval timer
//
function stopUpdateTimer()
{
    if (updateInterval) {
        clearInterval(updateInterval);
        updateInterval = null;
    }

}


function update_status(){
	
	var state = iTunes_player_state();
	var max_play = document.getElementById("auto_play_songs").value;
		
		if (state == "stopped"){
			if(_current_track >= max_play-1) { // current_track starts from 0.
				stop_auto_play();
				return null;
			} else{
				show_rss_track(_current_track + 1);
				say_song_information(_current_track);
				iTunes_next_track();
				iTunes_play();
			}
	}
}


//
// iTunes library
//

function do_appleScript(command) {
	
	if (window.widget){
		var obj = widget.system("/usr/bin/osascript -e  "+ "'" + command + "'",null);
		return obj.outputString;
		} else {
		return null;
		}
}

function iTunes_activate(){
	return do_appleScript('tell application \"iTunes\" to activate');
}

function iTunes_quit(){
	return do_appleScript('tell application \"iTunes\" to quit');
}

function iTunes_play(){
	return do_appleScript('tell application \"iTunes\" to play');
}

function iTunes_stop(){
	return do_appleScript('tell application \"iTunes\" to stop');
}

function iTunes_pause(){
	return do_appleScript('tell application \"iTunes\" to pause');
}

function iTunes_next_track(){
	return do_appleScript('tell application \"iTunes\" to next track');
}

function iTunes_previous_track(){
	return do_appleScript('tell application \"iTunes\" to previous track');
}

function iTunes_player_state(){
	var state = do_appleScript('tell application \"iTunes\" to player state');
	return state.substring(0,state.length-1); // remove strange code at last
}

function iTunes_player_position(){
	return do_appleScript('tell application \"iTunes\" to player position');
}

function iTunes_show(){
	return do_appleScript('tell application \"System Events\" to set visible of process \"iTunes\" to true');
}

function iTunes_hide(){
	return do_appleScript('tell application \"System Events\" to set visible of process \"iTunes\" to false');
}

function iTunes_open(location){
	return do_appleScript('tell application \"iTunes\" to  open location \"'+ location +'\"');
}

function iTunes_is_playing(){ // to be sharpened.
	
	if (iTunes_is_running() == true){
		var state = iTunes_player_state();
		return (state == 'playing');
	} else {
		
		return false
	}
}

function iTunes_is_running(){

	var str = widget.system("/bin/ps ax | grep iTunes", null).outputString;
	return (str.indexOf('Applications/iTunes.app/Contents/MacOS/iTunes') >= 0)

//var state = do_appleScript('tell application \"System Events\" to exists application process \"iTunes\"')
//return state.substring(0,state.length-1); 

}

function iTunes_move_playlist_position(position){
	//must be used just after playlist is loaded.
	
	//do_appleScript('tell application \"iTunes\" to activate');
	do_appleScript('tell application \"iTunes\" to play');
	do_appleScript('tell application \"iTunes\" to stop');
	
	for (var i = 0; i < position; i ++) {
		do_appleScript('tell application \"iTunes\" to next track');
	}
}

function delay(seconds){
	return do_appleScript('delay ' + seconds);


}
//
// save and retrieve preferences.
//
function load_preferences(){

	document.getElementById('category').object.setSelectedIndex(widget.preferenceForKey('category'));
	document.getElementById('store').selectedIndex	= widget.preferenceForKey('store');
	document.getElementById('auto_play_songs').value	= widget.preferenceForKey('auto_play_songs');
	
	document.getElementById('hide_itunes').checked	= (widget.preferenceForKey('hide_itunes')=='true');
	document.getElementById('speak_ranking').checked = (widget.preferenceForKey('speak_ranking')=='true');

	update_max_play();
}

function save_preferences(){

	var selected_genre = document.getElementById('category').object.getSelectedIndex();
	var selected_store = document.getElementById('store').selectedIndex;
	var auto_play_songs = document.getElementById('auto_play_songs').value;
	var hide_itunes = document.getElementById('hide_itunes').checked;
	var speak_ranking = document.getElementById('speak_ranking').checked;

	widget.setPreferenceForKey(selected_genre.toString(), 'category');
	widget.setPreferenceForKey(selected_store.toString(), 'store');
	widget.setPreferenceForKey(auto_play_songs.toString(), 'auto_play_songs');
	widget.setPreferenceForKey(hide_itunes.toString(), 'hide_itunes');	
	widget.setPreferenceForKey(speak_ranking.toString(), 'speak_ranking');
	
}

//
// click functions.
//

function click_on_song(){
	stop_auto_play();
	widget.openURL(_current_song_URL);	
}

function click_on_album(){
	stop_auto_play();
	widget.openURL(_current_album_URL);	
}

function click_on_artist(){
	stop_auto_play();
	widget.openURL(_current_artist_URL);	
}

function click_on_logo(){
	widget.openURL('http://blog.goo.ne.jp/howesound/');	
}


// basic functions

function parse_escape_code(source){
	
	var str = source;
		
	str = str.replace(/&#39;/g,"'");
	str = str.replace(/&#34;/g,'"');
	str = str.replace(/&amp;/g,"&");
		
	return str;

}


function string_between(str, delimiter1,delimiter2)	
{	
	str = str.substring(str.indexOf(delimiter1),str.length);
	str = str.substring(delimiter1.length,str.indexOf(delimiter2,0));
	return(str);
}

function delimitered_by(str,delimiter)
{	//return array delimiterd by str.
	
	var aArray = new Array();
	
	if(str.indexOf(delimiter) < 0)
	{ return([str]);
	}
	
	do {    index = str.indexOf(delimiter);
			each = str.substr(0,index)
			aArray.push(each);
			str = str.substr(index+delimiter.length,str.length)
		} while (str.indexOf(delimiter)>=0);
		
	aArray.push(str);
	return(aArray);
}

function say_word(word){

	//widget.system("/usr/bin/osascript -e 'say " + "\"" + word + "\" without completion" +"'" , null);
	
	str = word.replace(/"'"/g,"\'");
	widget.system("/usr/bin/say " + "'" + str + "'" , null);


}

function say_song_information(track){

	if(document.getElementById('speak_ranking').checked){
		var this_item = _rss_items[track];
		var song = RSS_retrieve_element(_rss_items[track],'itms:song').replace(/\(.+?\)/g,'');
		var artist = RSS_retrieve_element(_rss_items[track],'itms:artist').replace(/\(.+?\)/g,'');
	
		var str = song + ' , by ' + artist;

		say_word(str);
	}
}

function say_category_information(){

	if(document.getElementById('speak_ranking').checked){
		var genre = document.getElementById('category').innerText;
		var str = 'itunes music shop top one hundred of , ' + genre + ', ';
		say_word(str);
	}
}

//
// back pane
//
function update_max_play(){

	document.getElementById("max_play_songs").innerText = document.getElementById("auto_play_songs").value;


}


//
// opacity effect is here.
//

var _update_opacity_timer_interval;
var _opacity_timer_elapsed_time;
var _opacity_timer_resolution = 50; //50 steps to hide and show.
var _opacity_timer_duration = 500;

function start_opacity_effect_update_timer()
{	
	_opacity_timer_elapsed_time = 0;	
	
    update_opacity_effect_display();

    if (!_update_opacity_timer_interval){
        _update_opacity_timer_interval = setInterval(update_opacity_effect_display, (_opacity_timer_duration/_opacity_timer_resolution));
	}
}

//
// Function: stop_opacity_effect_update_timer()
// Remove the interval timer
//
function stop_opacity_effect_update_timer()
{
    if (_update_opacity_timer_interval) {
        clearInterval(_update_opacity_timer_interval);
        _update_opacity_timer_interval = null;
		_opacity_timer_elapsed_time = 0;
    }
}

function update_opacity_effect_display(){

	_opacity_timer_elapsed_time = _opacity_timer_elapsed_time + 1;

	if(_opacity_timer_elapsed_time<(_opacity_timer_resolution/2)){
		// input1 and erase
		var opacity = 1-(_opacity_timer_elapsed_time/(_opacity_timer_resolution/2));
		
		// change opacity only.
		document.getElementById("rank").style.opacity = opacity;
		document.getElementById("song").style.opacity = opacity;
		document.getElementById("album").style.opacity = opacity;
		document.getElementById("artist").style.opacity = opacity;
		document.getElementById("album_image").style.opacity = opacity;
		document.getElementById("by").style.opacity = opacity;

	
	} else {
		// input2 and show
		// just once.
		
		if(document.getElementById("song").innerText != _current_song){
			document.getElementById("album_image").src = _current_album_source;
			document.getElementById("rank").innerText = _current_rank;
			document.getElementById("song").innerText = _current_song;
			document.getElementById("album").innerText = _current_album;
			document.getElementById("artist").innerText = _current_artist;
			//delay(0.1);
			
			var opacity = 0;
			
		} else {
		
		var opacity = (_opacity_timer_elapsed_time-(_opacity_timer_resolution/2))/(_opacity_timer_resolution/2);

		}
		
		// change opacity as well.
		document.getElementById("rank").style.opacity = opacity;
		document.getElementById("song").style.opacity = opacity;
		document.getElementById("album").style.opacity = opacity;
		document.getElementById("artist").style.opacity = opacity;
		document.getElementById("album_image").style.opacity = opacity;
		document.getElementById("by").style.opacity = opacity;

	}
	
	if(_opacity_timer_elapsed_time > _opacity_timer_resolution){
		stop_opacity_effect_update_timer();
	}


}



// test mode

function test(){
	//document.getElementById("text").innerText = iTunes_player_position();
	//iTunes_quit()
	//iTunes_open("itms://phobos.apple.com/WebObjects/MZStore.woa/wa/viewTop?id=24&popId=1");
	//var state = iTunes_player_state();
	//document.getElementById("test_text").innerText = (state == "stopped");
	
	//fetch_from('http://dic.yahoo.co.jp/dsearch?enc=UTF-8&p=speak&stype=0&dtype=1');
	//fetch_from('http://homepage3.nifty.com/aya_js/js2/js208.htm');
	
	fetch_from('http://ax.phobos.apple.com.edgesuite.net/WebObjects/MZStore.woa/wpa/MRSS/topsongs/sf=143441/genre=21/limit=10/rss.xml');
	
}

